﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Reflection;
using Windows.UI.Xaml;

namespace Column_Types
{
    public class StocksViewModel : INotifyPropertyChanged
       {

        ObservableCollection<StockData> data;
        Random r = new Random(123345345);
        Random p1 = new Random(123345345);    
        List<string> StockSymbols = new List<string>();
            
        public ObservableCollection<StockData> Stocks
        {
            get
            {
                return this.data;
            }
            set
            {
                this.data = value;
                RaisePropertyChanged("Stocks");
            }
        }

        public StocksViewModel()
        {
            this.data = new ObservableCollection<StockData>();
            this.AddRows(100);          
        }             

        private void AddRows(int count)
        {
            for (int i = 0; i < count; ++i)
            {
                var newRec = new StockData();
                newRec.Symbol = ChangeSymbol();
                newRec.Trade1 = Math.Round(r.NextDouble() * 30, 2);
                newRec.Trade2 = Math.Round(r.NextDouble() * 12, 2);
                newRec.Trade3 = Math.Round(r.NextDouble() * 34, 2);
                newRec.Trade4 = Math.Round(r.NextDouble() * 56, 2);
                newRec.Trade5 = Math.Round(r.NextDouble() * 76, 2);
                newRec.Trade6 = Math.Round(r.NextDouble() * 33, 2);
                newRec.Trade7 = Math.Round(r.NextDouble() * 76, 2);
                newRec.Trade8 = Math.Round(r.NextDouble() * 26, 2);
                newRec.Trade9 = Math.Round(r.NextDouble() * 25, 2);
                newRec.Trade10 = Math.Round(r.NextDouble() * 32, 2);
                newRec.Trade11 = Math.Round(r.NextDouble() * 46, 2);
                newRec.Trade12 = Math.Round(r.NextDouble() * 52, 2);
                newRec.Trade13 = Math.Round(r.NextDouble() * 76, 2);
                newRec.Trade14 = Math.Round(r.NextDouble() * 21, 2);
                newRec.Trade15 = Math.Round(r.NextDouble() * 32, 2);
                newRec.Trade16 = Math.Round(r.NextDouble() * 31, 2);
                newRec.Trade17 = Math.Round(r.NextDouble() * 23, 2);
                newRec.Trade18 = Math.Round(r.NextDouble() * 51, 2);
                newRec.Trade19 = Math.Round(r.NextDouble() * 20, 2);
                newRec.Trade20 = Math.Round(r.NextDouble() * 30, 2);
                newRec.Trade21 = Math.Round(r.NextDouble() * 26, 2);
                newRec.Trade22 = Math.Round(r.NextDouble() * 42, 2);
                newRec.Trade23 = Math.Round(r.NextDouble() * 43, 2);
                newRec.Trade24 = Math.Round(r.NextDouble() * 12, 2);
                newRec.Trade25 = Math.Round(r.NextDouble() * 16, 2);
                newRec.Trade26 = Math.Round(r.NextDouble() * 19, 2);
                newRec.Trade27 = Math.Round(r.NextDouble() * 49, 2);
                newRec.Trade28 = Math.Round(r.NextDouble() * 64, 2);
                newRec.Trade29 = Math.Round(r.NextDouble() * 66, 2);
                newRec.Trade30 = Math.Round(r.NextDouble() * 09, 2);
                newRec.Trade31 = Math.Round(r.NextDouble() * 11, 2);
                newRec.Trade32 = Math.Round(r.NextDouble() * 23, 2);
                newRec.Trade33 = Math.Round(r.NextDouble() * 17, 2);
                newRec.Trade34 = Math.Round(r.NextDouble() * 15, 2);
                newRec.Trade35 = Math.Round(r.NextDouble() * 43, 2);
                newRec.Trade36 = Math.Round(r.NextDouble() * 53, 2);
                newRec.Trade37 = Math.Round(r.NextDouble() * 63, 2);
                newRec.Trade38 = Math.Round(r.NextDouble() * 33, 2);
                newRec.Trade39 = Math.Round(r.NextDouble() * 43, 2);
                newRec.Trade40 = Math.Round(r.NextDouble() * 19, 2);
                newRec.Trade41 = Math.Round(r.NextDouble() * 12, 2);
                newRec.Trade42 = Math.Round(r.NextDouble() * 12, 2);
                newRec.Trade43 = Math.Round(r.NextDouble() * 45, 2);
                newRec.Trade44 = Math.Round(r.NextDouble() * 26, 2);
                newRec.Trade45 = Math.Round(r.NextDouble() * 23, 2);
                data.Add(newRec);
            }
        }
        private String ChangeSymbol()
        {
            StringBuilder builder = new StringBuilder();
            Random random = new Random();
            char ch;

            do
            {
                builder = new StringBuilder();
                for (int i = 0; i < 4; i++)
                {
                    ch = Convert.ToChar(Convert.ToInt32(Math.Floor(26 * random.NextDouble() + 65)));
                    builder.Append(ch);
                }

            } while (StockSymbols.Contains(builder.ToString()));

            StockSymbols.Add(builder.ToString());
            return builder.ToString();
        }

   
        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisePropertyChanged(String prop)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(prop));
            }
        }
    }
}
